
```
  █████▒██▓   ▓██   ██▓ ██▓ ███▄    █   ▄████    ▄▄▄█████▓ ▒█████   █     █░▓█████  ██▀███
▓██   ▒▓██▒    ▒██  ██▒▓██▒ ██ ▀█   █  ██▒ ▀█▒   ▓  ██▒ ▓▒▒██▒  ██▒▓█░ █ ░█░▓█   ▀ ▓██ ▒ ██▒
▒████ ░▒██░     ▒██ ██░▒██▒▓██  ▀█ ██▒▒██░▄▄▄░   ▒ ▓██░ ▒░▒██░  ██▒▒█░ █ ░█ ▒███   ▓██ ░▄█ ▒
░▓█▒  ░▒██░     ░ ▐██▓░░██░▓██▒  ▐▌██▒░▓█  ██▓   ░ ▓██▓ ░ ▒██   ██░░█░ █ ░█ ▒▓█  ▄ ▒██▀▀█▄
░▒█░   ░██████▒ ░ ██▒▓░░██░▒██░   ▓██░░▒▓███▀▒     ▒██▒ ░ ░ ████▓▒░░░██▒██▓ ░▒████▒░██▓ ▒██▒
 ▒ ░   ░ ▒░▓  ░  ██▒▒▒ ░▓  ░ ▒░   ▒ ▒  ░▒   ▒      ▒ ░░   ░ ▒░▒░▒░ ░ ▓░▒ ▒  ░░ ▒░ ░░ ▒▓ ░▒▓░
 ░     ░ ░ ▒  ░▓██ ░▒░  ▒ ░░ ░░   ░ ▒░  ░   ░        ░      ░ ▒ ▒░   ▒ ░ ░   ░ ░  ░  ░▒ ░ ▒░
 ░ ░     ░ ░   ▒ ▒ ░░   ▒ ░   ░   ░ ░ ░ ░   ░      ░      ░ ░ ░ ▒    ░   ░     ░     ░░   ░
           ░  ░░ ░      ░           ░       ░                 ░ ░      ░       ░  ░   ░
               ░ ░

Bash tool for mass encryption & backup.

License: MIT
Created by: Vitali Barozzi
```

# [](#installing)Installing

```sh
git clone 'https://github.com/vitalibarozzi/Flying-Tower' && cd Flying-Tower && make install

# or

npm install flying-tower && cd node_modules/flying-tower && make install
```
# [](#usage)Usage

```sh
# verbose: [-v]
# version: [-V]
# debug  : [-d]
# help   : [-h]
# test   : [-t]

# lock  : [-l <path>]
# unlock: [-u <path>]
# key   : [-k <key>] // if ommited will prompt for the password
# output: [-o <path>] // if ommited $PWD will be used
```

```sh
# Lock a file/directory:

ft -l myfolder
```

```sh
# Unlock a locked tower file:

ft -u myfolder.ft
```

```sh
# Choose output path:

ft -l myfolder -o /media/xxx/myFlashDrive/
```

```sh
# Multiple targets

ft -l onefolder -l otherfolder -l idk # or ft -l "{onefolder,otherfolder,idk}"
# same for unlocking
ft -u onefolder.ft -u otherfolder.ft -u idk.ft # or ft -u "{onefolder,otherfolder,idk}.ft"
```

```sh
# Testing before using it in your precious files

ft -t # will lock and unlock some bogus files to see if everything is ok.
```
# [](#fancy)Getting Fancy

```sh
# Globbin and Brace Expansion:

ft -vk '123' -l "{onefolder,otherfolder,bin,idk}" # onefolder, otherfolder, bin, idk

ft -vk '123' -l "folder{1..3}" # folder1, folder2, folder3

ft -vk '123' -l "{folder{0..1},otherdir{A..B}}" # folder0, folder1, otherdirA, otherdirB

ft -vk '123' -l "*SATAN*" # mySATAN.txt, someOtherFileWithSATANInTheName.jpg

ft -vk '123' -l "*.txt" # anything.txt, otherthing.txt, zzz.txt

ft -vk '123' -l "d*" # dir1, dirXXX, directions.txt

ft -vk '123' -l "./**/*.jpg" # lock all .jpg files recursively from the current folder

ft -vk '123' -u "**/*.ft" # unlock all towers recursively from the current folder

ft -vk '123' -l "**/*" # set it loose to lock recursevly all files.

# Weird things to notice

# only braces and wild cards need double quotes, but you can quote everything if you want.

ft -vk '123' -l "*.{sh,txt}" # all files with .sh extension and .txt extension.

ft -vk '123' -l "f{A..B}.{txt,log}" # fA.txt, fA.log, fB.txt fB.log

ft -vk '123' -l . # lock current folder.

ft -vk '123' -l .. # lock parent folder.

ft -vk '123' -l ~ # lock home folder. (/home/user) !CAREFUL!

ft -vk '123' -l / # lock root. (Will not work, for safety)

ft -vk '123' -l "~/*" # lock all files/folders inside home folder. (individualy)

ft -vk '123' -l "*" # lock everything inside current folder. (individualy)

ft -vk '123' -u "*.ft" # unlock all towers in current folder.
```

# [](#example)Example usage

[![asciicast](https://asciinema.org/a/oibnsqjcmiMdbvVqvBm0zqr7j.png)](https://asciinema.org/a/oibnsqjcmiMdbvVqvBm0zqr7j)

# [](#testing)Testing

[![asciicast](https://asciinema.org/a/wZdUEDcii48y7Gkna63uGyw1d.png)](https://asciinema.org/a/wZdUEDcii48y7Gkna63uGyw1d)


* * *
# [](#goals)Goals
```
v0.2.0 — add Hashing & FTP for cloud Backup
```
# [](#license)License
```
MIT License

Copyright (c) 2017 J. V. Vitali Barozzi

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.```
