

get_absolut_path() { --r; local final_path target="${1:-}";

  # check if it aint empty
  [[ -n ${1:-} ]] || return 1;

  # Transform path
  if [[ $target =~ ^\.\. ]]; then # case parent
    intermediary="$(dirname "${PWD}")${target:1:2}";
  elif [[ $target =~ ^\. ]]; then # case current
    intermediary="${PWD}${target:1}";
  elif [[ $target =~ ^~ ]]; then # case home
    intermediary="${HOME}${target}";
  elif [[ $target =~ ^/ ]]; then # case already absolut
    intermediary="${target}";
  else
    intermediary="${PWD}/${target}";
  fi

  # Get rid of the last slash
  if [[ $intermediary =~ /$ ]]; then
      final_path="${intermediary::-1}";
    else
      final_path="${intermediary}";
  fi

  echo "$final_path";
}

check_absolut_path() { --r;

    # 1 Cant be empty
    [[ -n ${1:-} ]] || { --log err "Internal: Empty path." && return 1; };

    # 2 Need to start with '/'
    [[ ${1:-} =~ ^/ ]] || { --log err "Path need to be absolut." && return 1; };

    # 3 Cannot contain blank spaces.
    [[ ${1:-}  =~ ' ' ]] && { --log err "Path cannot contain blank spaces." && return 1; };

    # 4 No //
    [[ ${1:-}  =~ "//" ]] && { --log err "No // allowed in path." && return 1; };

    # 5 Check if path exist
    [[ -e ${1:-} ]] || { --log err "Path ${1:-} dosent exist." && return 1; };

    # Can't be a folder if --nofolder was passed (used in unlocking)
    { [[ ${2:-} == '--nofolder' ]] && [[ -d $path ]]; } && { --log err "Can't unlock folders." && return 1; };

  return 0;
}
