--test() {

  rm -rf ~/.tester* &> /dev/null

  prepare() { local repeat="${1:-}" folders="${2:-}" files="${3:-}" count="${4:-}";

    echo && --log input "PREPARING TEST"

    --log input "Repeats: $repeat Number of folders: $folders Files inside: $files of ${count}M"

    declare -i i=0;

    until [[ $i -eq "$folders" ]]; do eval i+=1;

      declare -i j=0;
      [[ -d ~/.tester${i}/ ]] && rm -rd ~/.tester${i}/; mkdir ~/.tester${i}/;

      until [[ $j -eq "$files" ]]; do j+=1;

        touch ~/.tester${i}/file${j};

        dd if=/dev/urandom of=~/.tester${i}/file${j} bs=1M count="${count}" 2> /dev/null

      done
    done
  }

  recursive_stress() { local repeat="${1:-}" folders="${2:-}" files="${3:-}" count="${4:-}";
    rm -rf ~/.tester* &> /dev/null;
    prepare "$repeat" "$folders" "$files" "${count}";

    --log input "RECURSIVE TEST"

    # Multiple locks / Multiple Unlocks
    declare -i counter=0
    until [[ $counter -eq $repeat ]]; do

      echo && --log input ">>>>>>>>>>>>> Locking internal files > 'ft -vk stress -l ~"/.tester*/*"'"

      ft -vk 'stress' -l ~"/.tester*/*" \
        || { --log err "Yeah... something went wrong with the test." && return 1; }

      echo && --log input ">>>>>>>>>>>>> Locking external folders > ft -vk stress -l ~"/.tester*"'"

      ft -vk 'stress' -l ~"/.tester*" \
        || { --log err "Yeah... something went wrong with the test." && return 1; }

      echo && --log input ">>>>>>>>>>>>> Unlocking external folders > ft -vk stress -u ~"/.tester*.ft"'"

      ft -vk 'stress' -u ~"/.tester*.ft" \
        || { --log err "Yeah... something went wrong with the test." && return 1; }

      echo && --log input ">>>>>>>>>>>>> Unlocking internal files > ft -vk stress -u ~"/.tester*/*.ft"'"

      ft -vk 'stress' -u ~"/.tester*/*.ft" \
        || { --log err "Yeah... something went wrong with the test." && return 1; }

      counter=$((counter + 1))
    done
  }

  recursive_stress 1 2 3 10 || { --log err "Didnt pass the test. :(" && return 1; };

  echo && --log success "Everything is ok. :D"

  rm -rf ~/.tester* &> /dev/null
}
